import sys
import pandas as pd
sys.path.append('../')
from utils.model_utils import prompt_model



def main():

    # load model
    model = "gpt-4o"

    bugs_df = pd.read_csv('../context/BPFBugFixes.csv')
    print(bugs_df)

    bug_commits = ''
    for commit_msg in bugs_df['Commit']:
        bug_commits += commit_msg + '\n<SEP>\n\n'
        

    prompt = f"You are an expert in ebpf. Here is a list of commit messages corresponding to previously identified bugs in the linux implementation of ebpf, separated with the <SEP> token.\n{bug_commits}\n\nCan you provide a list of descriptive categories for the different kinds of bugs that can occur in ebpf. Include a description of what each bug category means."
    
    print(f'--------<prompt>---------')
    print(prompt)

    print(f'--------<output>----------')

    # prompt model
    output = prompt_model(model, prompt)

    print(output)
    bugs_df = pd.DataFrame(columns=['bug_class', 'description'])
    for i, bug_type in enumerate(output.split('\n\n')):
        bugs_df.loc[i, 'bug_class'] = bug_type.split(':')[0].split('.')[1].strip()
        bugs_df.loc[i, 'description'] = bug_type.split(':')[-1].strip()
    
    bugs_df.to_json('BPFBugCategories.json', orient='records')

    
if __name__ == "__main__":
    main()


# to run file
# python -u main_high_level_categories.py 2>&1 | tee output_high_level_categories.txt
