import os
import sys
import matplotlib.pyplot as plt
import numpy as np
sys.path.append('../')
from utils.data_utils import load_file


def main():

    root_path = '../../data/all_generated_tests/'

    baseline_types = ['bug_guided_code_diff', 'target_section', '3shot_random']
    plt.figure(figsize=(8, 6))
    plt.rcParams.update({'font.size': 18})
    for baseline_type in baseline_types:
        generated_test_files = [file for file in os.listdir(f'{root_path}/{baseline_type}/processed')]


        num_lines = []
        for i, file in enumerate(generated_test_files):
            test_content = load_file(f'{root_path}/{baseline_type}/processed/{file}')
            test_code = test_content.split('-- asm')[1].split('-- result')[0]
            test_code_lines = [line for line in test_code.split('\n') if line.strip() != '']
            num_lines.append(len(test_code_lines))


        bins = range(0, 50, 2)
        # Plotting the histogram          
        plt.hist(num_lines, bins=bins, label = baseline_type, log=True, alpha=0.4)

    # Adding title and labels
    plt.title(f'Test complexity distribution: eBPF')
    plt.xlabel('#lines')
    plt.ylabel('Frequency')
    plt.legend(loc='upper right')
    
    plt.savefig(f'./num_lines_distribution_ebpf.png')





if __name__ == "__main__":
    main()
    